gui = gui or GuiCreate()
GuiStartFrame(gui)

max_uses = max_uses or (ModSettingGet("lemmings.sandbox_mode") and 99 or 20)

if not actions or GlobalsGetValue("lemmings_refresh_max_uses", "0") == "1" then
  GlobalsSetValue("lemmings_refresh_max_uses", "0")
  actions = {
    { name = "climber", uses_remaining = max_uses },
    { name = "umbrella", uses_remaining = max_uses },
    { name = "exploder", uses_remaining = max_uses },
    { name = "blocker", uses_remaining = max_uses },
    { name = "builder", uses_remaining = max_uses },
    { name = "digger_straight", uses_remaining = max_uses },
    { name = "miner", uses_remaining = max_uses },
    { name = "digger_down", uses_remaining = max_uses },
  }
end

local lemmings_action_id_performed = tonumber(GlobalsGetValue("lemmings_action_id_performed", "-1"))
if lemmings_action_id_performed > 0 then
  actions[lemmings_action_id_performed].uses_remaining = actions[lemmings_action_id_performed].uses_remaining - 1
  GlobalsSetValue("lemmings_action_id_performed", "-1")
  GamePlaySound("mods/lemmings/audio/lemmings.bank", "MOUSEPRE", 0, 0)
end

function get_distance2( x1, y1, x2, y2 )
	return ( x2 - x1 ) ^ 2 + ( y2 - y1 ) ^ 2
end

local screen_width, screen_height = GuiGetScreenDimensions(gui)
-- print('screen_width (' .. tostring(screen_width) .. ':'.. type(screen_width) .. ')')
local zoom = 2
local x, y = screen_width / 2 - (544 / 2 / zoom), screen_height - 65 --150, 290
local NonInteractive = 2
active = active or 1

local mx, my = DEBUG_GetMouseWorld()
local prey = EntityGetInRadiusWithTag(mx, my, 10, "prey")
local lemmings = {}
for i, v in ipairs(prey) do
  if EntityGetName(v) == "Lemming" then
    lemmings[#lemmings+1] = v
  end
end

-- Closest to mouse cursor
local closest_lemming_id = 0
local closest_lemming_distance = 9999999999999999999999
for i, v in ipairs(lemmings) do
  local lemming_x, lemming_y = EntityGetTransform(v)
  local dist = get_distance2(lemming_x, lemming_y, mx, my)
  if dist < closest_lemming_distance then
    closest_lemming_id = v
    closest_lemming_distance = dist
  end
end

if closest_lemming_id > 0 then
  local mxRaw, myRaw = ComponentGetValue2(controls_comp, "mMousePositionRaw")
  local scale_x, scale_y = screen_width / 1280, screen_height / 720
  local sx, sy = mxRaw * scale_x, myRaw * scale_y
  GuiImage(gui, 5001, sx - 7, sy - 7, "mods/lemmings/files/cursor.png", 1, 1, 1)
  GuiImage(gui, 5000, sx - 10, sy - 10, "data/debug/whitebox.png", 0, 1, 1)
  local clicked, right_clicked, hovered, x, y, width, height, draw_x, draw_y, draw_width, draw_height = GuiGetPreviousWidgetInfo(gui)
  if clicked and actions[active].uses_remaining > 0 then
    for i, comp in ipairs(EntityGetComponentIncludingDisabled(closest_lemming_id, "VariableStorageComponent") or {}) do
      if ComponentGetValue2(comp, "name") == "command" then
        ComponentSetValue2(comp, "value_string", actions[active].name)
      end
    end
  end
end

for i=0, 7 do
  local uses_remaining_tens = math.floor(actions[i+1].uses_remaining / 10)
  local uses_remaining_ones = actions[i+1].uses_remaining % 10
  -- GuiImage( gui:obj, id:int, x:number, y:number, sprite_filename:string, alpha:number = 1, scale:number = 1, scale_y:number = 0, rotation:number = 0, rect_animation_playback_type:int = GUI_RECT_ANIMATION_PLAYBACK.PlayToEndAndHide, rect_animation_name:string = "" ) ['scale' will be used for 'scale_y' if 'scale_y' equals 0.]
  GuiOptionsAddForNextWidget(gui, NonInteractive)
  GuiZSetForNextWidget(gui, 1)
  GuiImage(gui, 2 + i,    x + 17 * zoom * i,            y,     "mods/lemmings/files/action_background" .. ((i+1) == active and "_active" or "") .. ".png", 1, (1/3) * zoom, (1/3) * zoom, 0, 1)
  GuiOptionsAddForNextWidget(gui, NonInteractive)
  GuiZSetForNextWidget(gui, 0.5)
  GuiImage(gui, 200 + i,  x + 1 + 17 * zoom * i,        y + 10 * zoom, "mods/lemmings/files/actions_sprite.xml", 1, (1/3) * zoom, (1/3) * zoom, 0, 1, actions[i+1].name)
  GuiOptionsAddForNextWidget(gui, NonInteractive)
  GuiZSetForNextWidget(gui, 0.5)
  GuiImage(gui, 2000 + i, x+1 + 4 * zoom        + 17 * zoom * i, y + 1 * zoom,  "mods/lemmings/files/numbers_sprite.xml", 1, (1/3) * zoom, (1/3) * zoom, 0, 1, tostring(uses_remaining_tens))
  GuiOptionsAddForNextWidget(gui, NonInteractive)
  GuiZSetForNextWidget(gui, 0.5)
  GuiImage(gui, 2100 + i, x+1 + 4 * zoom + (13/3) * zoom + 17 * zoom * i, y + 1 * zoom,  "mods/lemmings/files/numbers_sprite.xml", 1, (1/3) * zoom, (1/3) * zoom, 0, 1, tostring(uses_remaining_ones))
  -- GuiOptionsRemove(gui, NonInteractive)
  -- GuiImageNinePiece( gui:obj, id:int, x:number, y:number, width:number, height:number, alpha:number = 1, sprite_filename:string = "data/ui_gfx/decorations/9piece0_gray.png", sprite_highlight_filename:string = "data/ui_gfx/decorations/9piece0_gray.png" )
  GuiImageNinePiece(gui, 9999 + i, x + 17 * zoom * i,   y, 17 * zoom, 26 * zoom, 0.0001)
  local clicked, right_clicked, hovered, x, y, width, height, draw_x, draw_y, draw_width, draw_height = GuiGetPreviousWidgetInfo(gui)
  if hovered then
    -- Draw an invisible image while the button is hovered which prevents mouse clicks from firing wands etc
    -- GuiColorSetForNextWidget(gui, 1, 0, 0, 1)
    -- GuiZSetForNextWidget(gui, info.z - 3)
    -- (NOITA BUG) Image click/mouse block area is always width * width
    local size = (26 / 20) * zoom
    GuiImage(gui, 5000, x, y, "data/debug/whitebox.png", 0, size, size)
    -- GuiImage(gui, 5000, x + 17 * zoom * i, y, "data/debug/whitebox.png", 1, size, size)
  end
  if clicked then
    active = i+1
    GamePlaySound("mods/lemmings/audio/lemmings.bank", "CHANGEOP", 0, 0)
  end
end
