ModLuaFileAppend("data/scripts/gun/gun_actions.lua", "mods/lemmings/files/gun_actions_append.lua")
ModMaterialsFileAdd("mods/lemmings/files/materials.xml")

ModRegisterAudioEventMappings("mods/lemmings/audio/GUIDs.txt")

if not ModSettingGet("lemmings.sandbox_mode") then
  ModLuaFileAppend("data/scripts/biome_scripts.lua", "mods/lemmings/files/biome_scripts_append.lua")
  ModLuaFileAppend("data/scripts/biomes/temple_wall_ending.lua", "mods/lemmings/files/temple_wall_ending_append.lua")
  local nxml = dofile_once("mods/lemmings/lib/nxml.lua")
  local content = ModTextFileGetContent("data/biome/_pixel_scenes.xml")
  local xml = nxml.parse(content)
  xml:first_of("mBufferedPixelScenes"):add_children(nxml.parse_many([[
    <PixelScene pos_x="235" pos_y="-140" just_load_an_entity="mods/lemmings/files/hatch_spawner_area.xml" />
    <PixelScene pos_x="190" pos_y="1570" just_load_an_entity="mods/lemmings/files/hatch_spawner_area.xml" />
    <PixelScene pos_x="190" pos_y="3115" just_load_an_entity="mods/lemmings/files/hatch_spawner_area.xml" />
    <PixelScene pos_x="190" pos_y="5150" just_load_an_entity="mods/lemmings/files/hatch_spawner_area.xml" />
    <PixelScene pos_x="190" pos_y="6685" just_load_an_entity="mods/lemmings/files/hatch_spawner_area.xml" />
    <PixelScene pos_x="190" pos_y="8740" just_load_an_entity="mods/lemmings/files/hatch_spawner_area.xml" />
    <PixelScene pos_x="190" pos_y="10780" just_load_an_entity="mods/lemmings/files/hatch_spawner_area.xml" />
  ]]))
  ModTextFileSetContent("data/biome/_pixel_scenes.xml", tostring(xml))
end

function OnPlayerSpawned(player)
  local controls_ent = EntityCreateNew()
  controls_comp = EntityAddComponent2(controls_ent, "ControlsComponent")
  local x, y = EntityGetTransform(player)
  if ModSettingGet("lemmings.sandbox_mode") then
    local EZWand = dofile_once("mods/lemmings/lib/EZWand.lua")
    local wand = EZWand{
      capacity = 1,
      spread = 0,
      manaMax = 100,
      castDelay = 30,
      rechargeTime = 30,
      manaChargeSpeed = 100,
    }
    wand:AddSpells("LEMMING")
    wand:SetSprite("mods/lemmings/files/lemming_spell_icon.png", 8, 12, 0, 0)
    wand:PutInPlayersInventory()
  else
    -- EntityLoad("mods/lemmings/files/hatch.xml", x, y - 50)
    -- EntityLoad("mods/lemmings/files/hatch_spawner_area.xml", x, y - 50)
  end
  -- LoadPixelScene( materials_filename:string, colors_filename:string, x:number, y:number, background_file:string, skip_biome_checks:bool = false, skip_edge_textures:bool = false, color_to_material_table:{string-string} = {}, background_z_index:int = 50 )
  -- LoadPixelScene("mods/lemmings/pixel_scene.png", "mods/lemmings/pixel_scene_visual.png", x - 200, y - 500, "mods/lemmings/pixel_scene_background.png", true, true, {}, 50)
end

function was_button_just_pressed(button)
  return GameGetFrameNum() == ComponentGetValue2(controls_comp, "mButtonFrame" .. button)
end

function OnWorldPreUpdate()
  local cx, cy = GameGetCameraPos()
  for i, entity_id in ipairs(EntityGetInRadiusWithTag(cx, cy, 300, "prey")) do
    if EntityGetName(entity_id) == "Lemming" then
      dofile("mods/lemmings/files/gui.lua")
      break
    end
  end

  local player = EntityGetWithTag("player_unit")[1]
  if player then
    if was_button_just_pressed("Interact") then
      local x, y, rot, scale_x = EntityGetTransform(player)
      local mx, my = DEBUG_GetMouseWorld()
      -- local lemming = EntityLoad("mods/lemmings/files/hatch.xml", x, y + 1)
      -- local lemming = EntityLoad("mods/lemmings/files/lemming.xml", x, y + 1)
      -- EntitySetTransform(lemming, x, y + 1, 0, scale_x)
      -- EntityLoad("mods/lemmings/files/test.xml", mx, my)
    end
    if was_button_just_pressed("RightClick") then
      local x, y, rot, scale_x = EntityGetTransform(player)
      -- local mx, my = DEBUG_GetMouseWorld()
      -- local lemming = EntityLoad("mods/lemmings/files/lemming.xml", mx, my)
      -- EntitySetTransform(lemming, mx, my, 0, scale_x)
      -- local lemming = EntityLoad("mods/lemmings/files/exit_door.xml", x, y + 1)
    end
    if was_button_just_pressed("LeftClick") then

    end
  end
end
